function []= GUI ()
close all;
square= 60;
rectangle('Position',[0,0,8*square,8*square]);    %draw board
set(gcf,'toolbar','none','menubar','none');
screensize= get(0,'ScreenSize');    %get screensize
set(0,'DefaultFigurePosition',screensize);   %position board to fit screen
%set(0,'PointerLocation',[screensize(3)/2 screensize(4)/2]); %position mouse in center of screen
set(1,'Renderer','OpenGL'); %support transparency if used
axis square;
%axis off;

set(gca,'xTick',30:60:450);
set(gca,'yTick',30:60:450);
set(gca,'xTickLabel',{'A','B','C','D','E','F','G','H'});
set(gca,'yTickLabel',{1,2,3,4,5,6,7,8});
axis([0 480 0 480]);

set(gcf,'Name','4760 Chess');
set(gcf,'NumberTitle','off');
%set(gcf,'Pointer','hand'); %we can actually define our own custom pointers.
%set(gcf,'Resize','off');

    %%%%CHESS PIECES : credit to Muhammad Suleman Shafqat
blackpawn1=imread('pieces\blackpawn1.png'); blackpawn1=blackpawn1(:,1:59,:);
blackpawn2=imread('pieces\blackpawn2.png'); blackpawn2=blackpawn2(:,1:59,:);
whitepawn1=imread('pieces\whitepawn1.png'); 
whitepawn2=imread('pieces\whitepawn2.png'); whitepawn2=whitepawn2(:,1:59,:);
blackrook1=imread('pieces\blackrook1.png');
blackrook2=imread('pieces\blackrook2.png');
whiterook1=imread('pieces\whiterook1.png');
whiterook2=imread('pieces\whiterook2.png');
blackbishop1=imread('pieces\blackbishop1.png');
blackbishop2=imread('pieces\blackbishop2.png');
whitebishop1=imread('pieces\whitebishop1.png');
whitebishop2=imread('pieces\whitebishop2.png');
blackknight1=imread('pieces\blackknight1.png'); 
blackknight2=imread('pieces\blackknight2.png'); blackknight2=blackknight2(:,1:59,:);
whiteknight1=imread('pieces\whiteknight1.png');
whiteknight2=imread('pieces\whiteknight2.png'); whiteknight2=whiteknight2(:,1:59,:);
blackqueen1=imread('pieces\blackqueen1.png');  blackqueen1=blackqueen1(1:59,:,:);
blackqueen2=imread('pieces\blackqueen2.png');
whitequeen1=imread('pieces\whitequeen1.png');
whitequeen2=imread('pieces\whitequeen2.png'); whitequeen2=whitequeen2(1:59,1:59,:);
blackking1=imread('pieces\blackking1.png');
blackking2=imread('pieces\blackking2.png');
whiteking1=imread('pieces\whiteking1.png');
whiteking2=imread('pieces\whiteking2.png');

%fix some pieces
blackbishop1=fixBishop(blackbishop1);
%blackbishop2 apparently needs one more fix. There appears
%to be a single white pixel remaining.
blackbishop2=fixBishop(blackbishop2);


%rotate images to be upright on chess board
blackpawn1=imrotate(blackpawn1,180,'crop');
blackpawn2=imrotate(blackpawn2,180,'crop');
whitepawn1=imrotate(whitepawn1,180,'crop');
whitepawn2=imrotate(whitepawn2,180,'crop');
blackrook1=imrotate(blackrook1,180,'crop');
blackrook2=imrotate(blackrook2,180,'crop');
whiterook1=imrotate(whiterook1,180,'crop');
whiterook2=imrotate(whiterook2,180,'crop');
blackbishop1=imrotate(blackbishop1,180,'crop');
blackbishop2=imrotate(blackbishop2,180,'crop');
whitebishop1=imrotate(whitebishop1,180,'crop');
whitebishop2=imrotate(whitebishop2,180,'crop');
blackknight1=imrotate(blackknight1,180,'crop');
blackknight2=imrotate(blackknight2,180,'crop');
whiteknight1=imrotate(whiteknight1,180,'crop');
whiteknight2=imrotate(whiteknight2,180,'crop');
blackqueen1=imrotate(blackqueen1,180,'crop');
blackqueen2=imrotate(blackqueen2,180,'crop');
%whitequeen1=imrotate(whitequeen1,180,'crop');
whitequeen2=imrotate(whitequeen2,180,'crop');
blackking1=imrotate(blackking1,180,'crop');
%blackking2=imrotate(blackking2,180,'crop');
whiteking1=imrotate(whiteking1,180,'crop');
%whiteking2=imrotate(whiteking2,180,'crop');
  
%color rectangles    
m=7; n=7;
for i=0 : m
    for j=0 : n
        num= i+j;   %color rectangle black if even square, white if odd square
        if rem(num,2) == 0
            rectangle('Position',[i*square,j*square,square,square],'FaceColor','k');
        else
            rectangle('Position',[i*square,j*square,square,square],'FaceColor','w');
        end
    end
end
hold all;

global turn;
turn = 1;

global blackrookA;
global blackknightA;
global blackbishopA;
global blackqueen;
global blackking;
global blackbishopB;
global blackknightB;
global blackrookB;
global blackpawnA;
global blackpawnB;
global blackpawnC;
global blackpawnD;
global blackpawnE;
global blackpawnF;
global blackpawnG;
global blackpawnH;
global whiterookA;
global whiteknightA;
global whitebishopA;
global whitequeen;
global whiteking;
global whitebishopB;
global whiteknightB;
global whiterookB;
global whitepawnA;
global whitepawnB;
global whitepawnC;
global whitepawnD;
global whitepawnE;
global whitepawnF;
global whitepawnG;
global whitepawnH;

%%%INIT FUNCTION%%%
    %draw first row: black royal pieces
    whiterookA= drawPiece(0,0,whiterook1);
    whiteknightA= drawPiece(60,0,whiteknight2);
    whitebishopA= drawPiece(120,0,whitebishop1);
    whitequeen= drawPiece(180,0,whitequeen2);
    whiteking= drawPiece(240,0,whiteking1);
    whitebishopB= drawPiece(300,0,whitebishop2);
    whiteknightB= drawPiece(360,0,whiteknight1);
    whiterookB= drawPiece(420,0,whiterook2);
    %draw second row: black pawn pieces
    whitepawnA= drawPiece(0,60,whitepawn2);
    whitepawnB= drawPiece(60,60,whitepawn1);
    whitepawnC= drawPiece(120,60,whitepawn2);
    whitepawnD= drawPiece(180,60,whitepawn1);
    whitepawnE= drawPiece(240,60,whitepawn2);
    whitepawnF= drawPiece(300,60,whitepawn1);
    whitepawnG= drawPiece(360,60,whitepawn2);
    whitepawnH= drawPiece(420,60,whitepawn1);
    %draw first row: white royal pieces
    blackrookA= drawPiece(0,420,blackrook2);
    blackknightA= drawPiece(60,420,blackknight1);
    blackbishopA= drawPiece(120,420,blackbishop2);
    blackking= drawPiece(240,420,blackking1);
    blackqueen= drawPiece(180,420,blackqueen2);
    blackbishopB= drawPiece(300,420,blackbishop1);
    blackknightB= drawPiece(360,420,blackknight2);
    blackrookB= drawPiece(420,420,blackrook1);
    %draw second row: white pawns
    blackpawnA= drawPiece(0,360,blackpawn2);
    blackpawnB= drawPiece(60,360,blackpawn2);
    blackpawnC= drawPiece(120,360,blackpawn1);
    blackpawnD= drawPiece(180,360,blackpawn2);
    blackpawnE= drawPiece(240,360,blackpawn1);
    blackpawnF= drawPiece(300,360,blackpawn2);
    blackpawnG= drawPiece(360,360,blackpawn1);
    blackpawnH= drawPiece(420,360,blackpawn2);

%modify pieces to make them transparent at the backgrounds
%make the pawns have transparent backgrounds

global alpha_data_pawn;
global alpha_data_rook;
global alpha_data_knight;
global alpha_data_bishop;
global alpha_data_queen;
global alpha_data_king;

global pawn_flag_array; %to keep track of which pawns have been queened
pawn_flag_array= zeros(1,16);   %initialize to zero

[m,n,~]=size(blackpawn1);
alpha_data_pawn=ones(m,n);
for i=1:m
    for j=1:n 
            if sum(blackpawn1(i,j,:))==0 
                alpha_data_pawn(i,j)=0;    
            end
    end
end

set(blackpawnA,'AlphaData',alpha_data_pawn);
set(blackpawnB,'AlphaData',alpha_data_pawn);
set(blackpawnC,'AlphaData',alpha_data_pawn);
set(blackpawnD,'AlphaData',alpha_data_pawn);
set(blackpawnE,'AlphaData',alpha_data_pawn);
set(blackpawnF,'AlphaData',alpha_data_pawn);
set(blackpawnG,'AlphaData',alpha_data_pawn);
set(blackpawnH,'AlphaData',alpha_data_pawn);
 
set(whitepawnA,'AlphaData',alpha_data_pawn);
set(whitepawnB,'AlphaData',alpha_data_pawn);
set(whitepawnC,'AlphaData',alpha_data_pawn);
set(whitepawnD,'AlphaData',alpha_data_pawn);
set(whitepawnE,'AlphaData',alpha_data_pawn);
set(whitepawnF,'AlphaData',alpha_data_pawn);
set(whitepawnG,'AlphaData',alpha_data_pawn);
set(whitepawnH,'AlphaData',alpha_data_pawn);

%make the rooks transparent
[m,n,~]=size(blackrook1);
alpha_data_rook=ones(m,n);
for i=1:m
    for j=1:n 
            if sum(blackrook1(i,j,:))==0 
                alpha_data_rook(i,j)=0;    
            end
    end
end
set(blackrookA,'AlphaData',alpha_data_rook);
set(blackrookB,'AlphaData',alpha_data_rook);

set(whiterookA,'AlphaData',alpha_data_rook);
set(whiterookB,'AlphaData',alpha_data_rook);

%make the knights transparent
[m,n,~]=size(blackknight1);
alpha_data_knight=ones(m,n);
for i=1:m
    for j=1:n 
            if sum(blackknight1(i,j,:))==0 
                alpha_data_knight(i,j)=0;    
            end
    end
end
set(blackknightA,'AlphaData',alpha_data_knight);
set(blackknightB,'AlphaData',alpha_data_knight);

set(whiteknightA,'AlphaData',alpha_data_knight);
set(whiteknightB,'AlphaData',alpha_data_knight);

%make the bishops transparent
[m,n,~]=size(blackbishop1);
alpha_data_bishop=ones(m,n);
for i=1:m
    for j=1:n 
            if sum(blackbishop1(i,j,:))==0 
                alpha_data_bishop(i,j)=0;    
            end
    end
end
set(blackbishopA,'AlphaData',alpha_data_bishop);
set(blackbishopB,'AlphaData',alpha_data_bishop);

set(whitebishopA,'AlphaData',alpha_data_bishop);
set(whitebishopB,'AlphaData',alpha_data_bishop);

%make the queens transparent
[m,n,~]=size(blackqueen1);
alpha_data_queen=ones(m,n);
for i=1:m
    for j=1:n 
            if sum(blackqueen1(i,j,:))==0 
                alpha_data_queen(i,j)=0;    
            end
    end
end
set(blackqueen,'AlphaData',alpha_data_queen);
set(whitequeen,'AlphaData',alpha_data_queen);

%make the kings transparent
[m,n,~]=size(blackking1);
alpha_data_king=ones(m,n);
for i=1:m
    for j=1:n 
            if sum(blackking1(i,j,:))==0 
                alpha_data_king(i,j)=0;    
            end
    end
end
set(blackking,'AlphaData',alpha_data_king);
set(whiteking,'AlphaData',alpha_data_king);

%parsePacket variables
%global turn;
%global endgame;
%global currentpiece;
%global currentpiecevar;
global myCursor;

cursor1=imread('pieces\cursorsmall.png');
cursor1=imrotate(cursor1,180);
cursor1=fixCursor(cursor1);
%cursor=rgb2gray(cursor);
  [m,n,~]=size(cursor1);
  alpha_data_cursor=ones(m,n);
  for i=1:m
      for j=1:n 
              if (cursor1(i,j,:))==255; 
                  alpha_data_cursor(i,j)=0;    
              end
      end
  end
    myCursor=imagesc(230,230,cursor1);
    set(myCursor,'AlphaData',alpha_data_cursor);
end

%changes the parts of a piece with internal 0s
function out=fixBishop(arg1)
 arg1(61-8,61-30,1)=1;
 arg1(61-9,61-31:61-30,1)=1;
 arg1(61-10,61-31:61-30,1)=1;
 arg1(61-11,61-31:61-29,1)=1;
 arg1(61-12,61-31:61-28,1)=1;
 arg1(61-13,61-32:61-28,1)=1;
 arg1(61-14,61-32:61-28,1)=1;
 arg1(61-15,61-32:61-28,1)=1;
 arg1(61-16,61-32:61-25,1)=1;
 arg1(61-17,61-31:61-25,1)=1;
 arg1(61-18,61-31:61-25,1)=1;
 arg1(61-19,61-31:61-25,1)=1;
 arg1(61-20,61-27:61-25,1)=1;
 arg1(61-21,61-26:61-25,1)=1;
 arg1(61-22,61-26:61-25,1)=1;
 arg1(61-23,61-26:61-25,1)=1;
 arg1(61-24,61-25,1)=1;
 arg1(61-25,61-25,1)=1;
 arg1(61-26,61-25,1)=1;
 out=arg1;
end

function [out] = fixCursor(cursor)
cursor(3,9,1)=254;
cursor(4,8,1)=254;
cursor(6,9,1)=254;
cursor(6,10,1)=254;
cursor(7,9,1)=254;
cursor(11,8,1)=254;
cursor(12,9,1)=254;
cursor(13,10,1)=254;
cursor(14,11,1)=254;
cursor(15,12,1)=254;
cursor(5,14,1)=254;
cursor(16,14,1)=254;
cursor(19,14,1)=254;
out=cursor;
end

%take coordinates and piece as parameters and move piece
function[out]= drawPiece(x,y,piece)
    xC= int16(x);
    yC= int16(y);
    xC= xC/60;  %re-adjust piece to fit square
    yC= yC/60;
    xC= xC*60;
    yC= yC*60;
    out= imagesc(xC,yC,piece);
end


